﻿using System;
using System.Collections.Generic;
using MvvmDataBindingDemo.Data;

namespace MvvmDataBindingDemo.DomainModel
{
    class Model : MarshalByRefObject
    {
        private Database _database;
        private Database Database
        {
            get
            {
                if (_database == null) _database = Database.Load(@"Data\Database.xml");
                return _database;
            }
        }

        public IList<Country> Countries { get { return Database.Countries; } }

        private ShipmentCalculator _shipmentCalculator = new ShipmentCalculator();
        public ShipmentCalculator ShipmentCalculator
        {
            get { return _shipmentCalculator; }
        }

        public void Send(Shipment shipment)
        {
            // actions on actually shipping the goods belong here
        }
    }
}
