﻿using System;

namespace MvvmDataBindingDemo.DomainModel
{
    class ShipmentCalculator : MarshalByRefObject
    {
        public  decimal? GetShipmentCost(Country country, Subdivision subdivision)
        {
            if (country == null) return null;

            switch (country.Name)
            {
                case "USA": return GetDomesticCost(subdivision);
                case "Canada": return GetCanadianCost(subdivision);
                default: return 25.00m;
            }
        }

        private decimal? GetDomesticCost(Subdivision state)
        {
            if (state == null) return null;

            switch (state.Abbreviation)
            {
                case "AK":
                case "HI": return 14.99m;

                // North-East
                case "ME":
                case "NH":
                case "VT":
                case "MA":
                case "RI":
                case "CT":
                case "NY":
                case "NJ":
                case "PA": return 5.99m;

                // mid-West and East Coast except Florida
                case "DE":
                case "MD":
                case "VA":
                case "NC":
                case "SC":
                case "GA":
                case "OH":
                case "IL":
                case "IN":
                case "MI":
                case "WV":
                case "KY":
                case "TN":
                    return 7.99m;

                default:
                    return 9.99m;
            }
        }

        private decimal? GetCanadianCost(Subdivision province)
        {
            if (province == null) return null;
            switch (province.Abbreviation)
            {
                case "NB":
                case "QC": return 10.99m;

                default:
                    return 12.99m;
            }
        }
    }
}
