﻿using System.Windows;

namespace MvvmDataBindingDemo
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, IFocusManager
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        public bool Focus(string childName)
        {
            var element = FindName(childName) as UIElement;
            if (element == null) return false;
            return element.Focus();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var viewModel = DataContext as MainWindowViewModel;
            if (viewModel != null)
            {
                viewModel.FocusManager = this;
            }
        }
    }
}
